using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Data.SqlClient;

namespace WithDataTableSelect
{
	public class FilterAndSort : System.Windows.Forms.Form
	{
		private System.Windows.Forms.DataGrid dataGrid;
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.TextBox textBox;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Button BtnFilterAndSort;
		private DataSet ds;

		public FilterAndSort()
		{
			InitializeComponent();

			// Setup DB-Connection, create and fill Dataset, show
			// Resultset in DataGrid
			SqlConnection cn = new SqlConnection(
				"data source=xeon;uid=sa;password=manager;database=northwind");
			ds = new DataSet("Orders");
			SqlDataAdapter da = new SqlDataAdapter("SELECT * FROM Orders",cn);
			da.TableMappings.Add("Table","Orders");
			da.Fill(ds);
			dataGrid.DataSource = ds.Tables["Orders"];
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.dataGrid = new System.Windows.Forms.DataGrid();
			this.textBox = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.BtnFilterAndSort = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.dataGrid)).BeginInit();
			this.SuspendLayout();
			// 
			// dataGrid
			// 
			this.dataGrid.CaptionText = "Orders from the Northwind Database";
			this.dataGrid.DataMember = "";
			this.dataGrid.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.dataGrid.Location = new System.Drawing.Point(8, 8);
			this.dataGrid.Name = "dataGrid";
			this.dataGrid.Size = new System.Drawing.Size(472, 152);
			this.dataGrid.TabIndex = 0;
			// 
			// textBox
			// 
			this.textBox.Location = new System.Drawing.Point(8, 184);
			this.textBox.Multiline = true;
			this.textBox.Name = "textBox";
			this.textBox.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.textBox.Size = new System.Drawing.Size(472, 120);
			this.textBox.TabIndex = 1;
			this.textBox.Text = "";
			this.textBox.WordWrap = false;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 168);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(100, 16);
			this.label1.TabIndex = 2;
			this.label1.Text = "Filtered and Sorted";
			// 
			// BtnFilterAndSort
			// 
			this.BtnFilterAndSort.Location = new System.Drawing.Point(8, 312);
			this.BtnFilterAndSort.Name = "BtnFilterAndSort";
			this.BtnFilterAndSort.Size = new System.Drawing.Size(472, 23);
			this.BtnFilterAndSort.TabIndex = 3;
			this.BtnFilterAndSort.Text = "Filter and Sort with the DataTable Select Method";
			this.BtnFilterAndSort.Click += new System.EventHandler(this.BtnFilterAndSort_Click);
			// 
			// FilterAndSort
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(488, 341);
			this.Controls.Add(this.BtnFilterAndSort);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.textBox);
			this.Controls.Add(this.dataGrid);
			this.Name = "FilterAndSort";
			this.Text = "Filtering and Sorting with the DataTable Select Method";
			((System.ComponentModel.ISupportInitialize)(this.dataGrid)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		[STAThread]
		static void Main() 
		{
			Application.Run(new FilterAndSort());
		}

		// Filter and Sort with the DataTable Select Method
		private void BtnFilterAndSort_Click(object sender, System.EventArgs e)
		{
			string  strText;
			string  strExpr;
			string  strSort;
			DataRow[] foundRows;
			DataTable myTable;
			myTable = ds.Tables["Orders"];

			// Setup Filter and Sort Criteria
			strExpr = "OrderDate >= '01.03.1998' AND OrderDate <= '31.03.1998'";
			strSort = "OrderDate DESC";
			
			// Use the Select method to find all rows matching the filter.
			foundRows = myTable.Select(strExpr, strSort);

			// Apply all Columns to the TextBox, this
			// must be done Roy-By-Row.
			strText = null;
			for (int i = 0 ; i <= foundRows.GetUpperBound(0); i++) 
			{
				for (int j = 0; j <= foundRows[i].ItemArray.GetUpperBound(0); j++) 
				{
					strText = strText + foundRows[i][j].ToString() + "\t";
				}
				strText = strText + "\r\n";
				textBox.Text = strText;
			}
		}
	}
}
